<?php

namespace FM\Controller;

use FM\Controller\FMCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use FM\Service\LocaisAtendimentoService;
use FM\Traits\TResponse;

class LocaisAtendimentoController extends FMCrud
{
    use TResponse;

    protected $LocaisAtendimentoService;

    public function __construct($crudService, $environment, LocaisAtendimentoService $LocaisAtendimentoService)
    {
        parent::__construct($crudService, $environment);
        $this->LocaisAtendimentoService = $LocaisAtendimentoService;
    }
    // INTEGRAÇÃO SM
    public function getContratosConfigurarLocais()
    {
        try {
            $data = $this->LocaisAtendimentoService->getContratosConfigurarLocais();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getLocaisSM(Request $request)
    {
        try {
            $data = $this->LocaisAtendimentoService->getLocaisSM($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function salvarLocalSm(Request $request)
    {
        try {
            $data = $this->LocaisAtendimentoService->salvarLocalSm($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
    // -----------
    public function getClientes()
    {
        try {
            $data = $this->LocaisAtendimentoService->getClientes();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getLocais(Request $request)
    {
        try {
            $data = $this->LocaisAtendimentoService->getLocais($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getTiposDeLocais(Request $request)
    {
        try {
            $data = $this->LocaisAtendimentoService->getTiposDeLocais($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getChecklistPadrao()
    {
        try {
            $data = $this->LocaisAtendimentoService->getChecklistPadrao();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getSetorLocalAtendimento()
    {
        try {
            $data = $this->LocaisAtendimentoService->getSetorLocalAtendimento();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function inserirNovoLocal(Request $request)
    {
        try {
            $data = $this->LocaisAtendimentoService->inserirNovoLocal($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getClientesQueAgrupamLocais()
    {
        try {
            $data = $this->LocaisAtendimentoService->getClientesQueAgrupamLocais();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getLocaisAgrupados(Request $request)
    {
        try {
            $data = $this->LocaisAtendimentoService->getLocaisAgrupados($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function alterarCorCliente(Request $request)
    {
        try {
            $data = $this->LocaisAtendimentoService->alterarCorCliente($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function atualizarLocal(Request $request)
    {
        try {
            $data = $this->LocaisAtendimentoService->atualizarLocal($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function inativarLocais(Request $request)
    {
        try {
            $data = $this->LocaisAtendimentoService->inativarLocais($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }


    // --- Funções da TAB NOVO TIPO DE LOCAL
    public function getTipoDeLocal()
    {
        try {
            $data = $this->LocaisAtendimentoService->getTipoDeLocal();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function atualizarTipoLocal(Request $request)
    {
        try {
            $data = $this->LocaisAtendimentoService->atualizarTipoLocal($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    // public function inserirTipoLocal(Request $request)
    // {
    //     try {
    //         $data = $this->LocaisAtendimentoService->inserirTipoLocal($request->getParameters());
    //         $this->sendResponse($data, 200);
    //     } catch (\Exception $ex) {
    //         $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
    //     }
    // }

    public function excluirTipoLocal(Request $request)
    {
        try {
            $data = $this->LocaisAtendimentoService->excluirTipoLocal($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    // ----------- FUNÇÕES GEOLOCALIZAÇÃO ------------
    public function salvarGeolocalizacao(Request $request)
    {
        try {
            $data = $this->LocaisAtendimentoService->salvarGeolocalizacao($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getGeolocalizacao(Request $request)
    {
        try {
            $data = $this->LocaisAtendimentoService->getGeolocalizacao($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}
