<?php

namespace FM\Service;

use FM\Factory\CalendarioFactory;
use FM\Service\FuncionariosHierarqService;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;

class CalendarioService
{

    protected $CalendarioFactory;
    protected $FuncionariosHierarqService;
    protected $Environment;
    protected $newCode;

    public function __construct(CalendarioFactory $CalendarioFactory, FuncionariosHierarqService $FuncionariosHierarqService, Environment $environment, NewCode $newCode)
    {
        $this->CalendarioFactory                    = $CalendarioFactory;
        $this->FuncionariosHierarqService           = $FuncionariosHierarqService;
        $this->environment                          = $environment;
        $this->newCode                              = $newCode;
    }

    public function getTarefasCalendario($parametros)
    {
        $listaOperadores = $this->FuncionariosHierarqService->montarHierarquiaOperadores($this->environment->getCdOperador());

        return $this->CalendarioFactory->getTarefasCalendario(array(
            "PERIODOINICIAL"    => $parametros['PERIODOINICIAL'],
            "PERIODOFINAL"      => $parametros['PERIODOFINAL'],
            "NRLOCALCLIENTE"    => $parametros['NRLOCALCLIENTE'],
            "NRLOCALCLIENTEPAI" => $parametros['NRLOCALCLIENTEPAI'],
            "NRATIVIDADE"       => $parametros['NRATIVIDADE'],
            "NRTIPOLOCALCLI"    => $parametros['NRTIPOLOCALCLI'],
            "CDOPERADOR"        => $parametros['CDOPERADOR'],
        ), $listaOperadores);
    }

    public function getLocaisCalendario($parametros)
    {
        $params = array(
            "IDTIPOLOCALCLI" => $parametros['IDTIPOLOCALCLI'],
        );

        return $this->CalendarioFactory->getLocaisCalendario($params);
    }

    public function getSetoresCalendario()
    {
        return $this->CalendarioFactory->getSetoresCalendario();
    }

    public function getAtividadesCalendario()
    {
        return $this->CalendarioFactory->getAtividadesCalendario();
    }

    public function getTipoDeLocal()
    {
        return $this->CalendarioFactory->getTipoDeLocal();
    }
}
